<?php

/**
 * Plugin Name:       MF Membership invoice
 * Plugin URI:        https://www.mario-flores.com/
 * Description:       Send invoice to user after paying membership 
 * Version:           5.0.0
 * Requires at least: 5.2
 * Requires PHP:      5.6
 * Author:            Mario Flores
 * Author URI:        https://mario-flores.com
 * License:           GPL v2 or later
 * License URI:       https://www.gnu.org/licenses/gpl-2.0.html
 * Text Domain:       mf_membership_invoice
 * Domain Path:       /languages
 */
require __DIR__ . '/vendor/autoload.php';

use Spipu\Html2Pdf\Html2Pdf;

add_action('ihc_payment_completed', 'mf_send_invoice', 99, 2);

function mf_send_invoice($uid = 0, $lid = 0)
{
    global $wpdb;
    $user = $wpdb->get_results("select * from {$wpdb->prefix}users where ID = " . $uid);
    if (!empty($user)) {

        $user_meta = $wpdb->get_results("select * from {$wpdb->prefix}usermeta where user_id = " . $uid);
        $meta_data = array();
        if (!empty($user_meta)) {
            foreach ($user_meta as $m) {
                $meta_data[$m->meta_key] = $m;
            }
        }
        $last_order = $wpdb->get_results("select * from {$wpdb->prefix}ihc_orders where uid = " . $uid . " order by id DESC limit 1");

        $last_invoice = $wpdb->get_results("select * from {$wpdb->prefix}invoices order by id DESC limit 1");
        if (empty($last_invoice)) {
            $number = 0;
        } else {
            $number = $last_invoice[0]->number;
            $number = $number + 1;
        }

        $html2pdf = new Html2Pdf();
        $html = '<div style="margin: 100px;">';
        $html .= '<h2><i>RICEVUTA DI PAGAMENTO QUOTA ASSOCIATIVA</i></h2>';
        $html .= '<br />';
        $html .= '<br />';
        $html .= '<br />';
        $html .= '<br />';
        $html .= '<br />';
        $html .= '<div style="text-align: right">';
        $html .= 'Gent.mo Dott./D.ssa<br />';
        $html .= $meta_data['first_name']->meta_value . ' ' . $meta_data['last_name']->meta_value . '<br />';
        $html .= $meta_data['indirizzodiresidenza']->meta_value . '<br />';
        $html .= 'Cap ' . $meta_data['cap']->meta_value . '<br />';
        $html .= 'Codice fiscale<br />';
        $html .= $meta_data['codicefiscale']->meta_value . '<br />';
        $html .= '</div>';
        $html .= '<br />';
        $html .= '<br />';
        $html .= 'RICEVUTA DI PAGAMENTO N.  ' . $number . ' / ' . date('Y') . '<br />';
        $html .= 'Descrizione: quota associativa anno ' . date('Y') . ' <br />';
        $html .= 'Importo € ' . $last_order[0]->amount_value . '<br />';
        $html .= '<br />';
        $html .= '<br />';
        $html .= '<br />';
        $html .= '<br />';
        $html .= 'Milano li ' . date('d-m-Y') . '<br />';
        $html .= '<br />';
        $html .= '<br />';
        $html .= '<div style="text-align: center; padding-left: 300px;">';
        $html .= 'Il presidente  <br />';
        $html .= '_________________________________ <br />';
        $html .= 'ANTONIO RAGUSA<br />';
        $html .= '</div>';
        $html .= '<br />';
        $html .= '<br />';
        $html .= '<div>';
        $html .= 'Esente da bollo ai sensi del art. 82 DLgs 117/2017.';
        $html .= '</div>';
        $html .= '<br />';
        $html .= '<br />';
        $html .= '<br />';
        $html .= '<div style="text-align: center">';
        $html .= 'GRUPPO G.E.O. ( GRUPPO EMERGENZE OSTETRICHE ) A.P.S . <br />';
        $html .= 'Piazza Firenze, 12<br />';
        $html .= '20154 Milano<br />';
        $html .= 'C.F. 97465750152<br />';
        $html .= '</div>';
        $html .= '</div>';

        $html2pdf->writeHTML($html);
        $file_name = wp_upload_dir();
        $file_name = $file_name['basedir'] . '/invoice' . $number . '.pdf';
        $html2pdf->output($file_name, 'F');

        $wpdb->query($wpdb->prepare(
            "insert into {$wpdb->prefix}invoices (number, date, body, user_id) values(%d, %s, %s, %d)",
            $number,
            date('Y-m-d H:i:s'),
            $html,
            $uid
        ));
        $body = "Gentile utente,\r\n
in allegato la ricevuta di pagamento della quota associativa ricevuto tramite il sito web gruppoemergenzeostetriche.it\r\n
Potrà accedere all'area riservata utilizando le credenziali prescelte durante la registrazione.\r\n
Cordiali saluti";
        $headers = 'From: Gruppo Emergenze Ostetriche <noreply@gruppoemergenzeostetriche.it>' . "\r\n";
        $attachments = array($file_name);
        wp_mail($user[0]->user_email, 'Ricevuta pagamento quota associativa', $body, $headers, $attachments);
    }
}

add_action('admin_menu', 'mf_invoices_page');
function mf_invoices_page()
{
    add_menu_page(
        'Memeber Invoices',
        'Member Invoices',
        'manage_options',
        'manage_option',
        'manage_load_option'
    );
}

function manage_load_option()
{
    global $wpdb;
    $file_name = wp_upload_dir();
    $file_name = $file_name['baseurl'].'/'; 
    $invoices = $wpdb->get_results("select {$wpdb->prefix}invoices.*, u.user_email, m.meta_value as 'name', l.meta_value as 'last'
        from {$wpdb->prefix}invoices 
        join {$wpdb->prefix}users as u on u.ID = {$wpdb->prefix}invoices.user_id 
        join {$wpdb->prefix}usermeta as m on m.user_id = u.ID 
        join {$wpdb->prefix}usermeta as l on l.user_id = u.ID
        group by {$wpdb->prefix}invoices.id
        order by id DESC");
    include(plugin_dir_path(__FILE__) . 'views/invoices.php');
}

add_shortcode('mf-test', 'mf_test');

function mf_test()
{

    mf_send_invoice(7914, 4);
}
